/* begincopyright
  Copyright (c) 1988 Xerox Corporation. All rights reserved.
  Use and copying of this software and preparation of derivative works based
  upon this software are permitted. Any distribution of this software or
  derivative works must comply with all applicable United States export
  control laws. This software is made available AS IS, and Xerox Corporation
  makes no warranty about the software, its performance or its conformity to
  any specification. Any person obtaining a copy of this software is requested
  to send their name and post office or electronic mail address to:
    PCR Coordinator
    Xerox PARC
    3333 Coyote Hill Rd.
    Palo Alto, CA 94304
  endcopyright */

/*
 * ThreadsInit.c
 *
 * Demers, November 13, 1990 2:11:23 pm PST
 *
 * Xerox Runtime threads package pre-initialization.
 *
 * This file calls XR_setjmp, so it should not be optimized.
 */

#include "xr/Threads.h"


void
XR_InitAndRun()
{
    extern struct XR_JmpBufRep XR_finalCleanupJmpBuf;
    extern void XR_FinalCleanup();
    extern void XR_InitAndRunInner();
    int xStatus;
    
    if( (xStatus = XR_setjmp(&XR_finalCleanupJmpBuf)) == 0 )
        XR_InitAndRunInner();
    XR_FinalCleanup(xStatus);
    /*NOTREACHED*/
}
